zoukankan      html  css  js  c++  java
  • 题解报告:hdu 1969 Pie(二分)

    Problem Description

    My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.
    My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size. 
    What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

    Input

    One line with a positive integer: the number of test cases. Then for each test case:
    ---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
    ---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.

    Output

    For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).

    Sample Input

    3
    3 3
    4 3 3
    1 24
    5
    10 5
    1 4 2 3 4 5 6 5 4 2

    Sample Output

    25.1327
    3.1416
    50.2655
    解题思路:题意就是把n块饼分给f+1个人,要求每个人分得一块相同且面积最大的饼,不能由几小块凑成。因此,考虑从最大面积S的饼中进行二分取点,但这里跟二分查找有点区别的,相当于在一条绳子上取点,如果发现中点可以使分得馅饼的人数不小于f+1,那么左端点值应该赋值为mid,去找分得更大面积的馅饼(仔细想想是很容易明白的)不然误差会变大;同理如果中点使得分得馅饼的人数小于f+1,说明只能找较小的面积,那么右端点也赋值为mid,这样最后就能较精确的找到那个点mid。
    AC代码:
     1 #include<bits/stdc++.h>
     2 using namespace std;
     3 const int maxn=10005;
     4 const double pi=acos(-1.0);
     5 const double eps=1e-7;
     6 int t,n,f,cnt;double L,R,mid,r,maxsize,s[maxn];
     7 int main(){
     8     while(~scanf("%d",&t)){
     9         while(t--){
    10             scanf("%d%d",&n,&f);f+=1;maxsize=0;
    11             for(int i=0;i<n;++i)scanf("%lf",&r),s[i]=pi*r*r,maxsize=max(maxsize,s[i]);//找出最大的馅饼面积  
    12             L=0,R=maxsize;
    13             while(R-L>eps){//因为只保留4位小数,所以精度控制在1e-7内即可(1e-8会超时)
    14                 mid=(R+L)/2,cnt=0;
    15                 for(int i=0;i<n;++i)cnt+=floor(s[i]/mid);//取整
    16                 if(cnt>=f)L=mid;//如果发现可以分的人更多,那么就往右边找
    17                 else R=mid;//否则说明只能找小的尺寸,即往左边找
    18             }
    19             printf("%.4f
    ",mid);
    20 } 21 } 22 return 0; 23 }
  • 相关阅读:
    Ananagrams(反片语)【map的应用】P114
    并查集初步——
    预处理器,编译器,汇编器,连接器
    https://pta.patest.cn/pta/test/15/exam/3/question/724
    stl入门--reverse函数
    无向图的深度遍历
    01背包
    动态规划——数字三角形(递归or递推or记忆化搜索)
    八皇后问题
    幂集的计算
  • 原文地址:https://www.cnblogs.com/acgoto/p/9545952.html
Copyright © 2011-2022 走看看